# -*- encoding: utf-8 -*-
# stub: whois 6.0.0 ruby lib

Gem::Specification.new do |s|
  s.name = "whois".freeze
  s.version = "6.0.0".freeze

  s.required_rubygems_version = Gem::Requirement.new(">= 0".freeze) if s.respond_to? :required_rubygems_version=
  s.require_paths = ["lib".freeze]
  s.authors = ["Simone Carletti".freeze]
  s.date = "2024-08-05"
  s.description = "Whois is an intelligent WHOIS client and parser written in pure Ruby. It can query registry data for IPv4, IPv6 and top level domains, and parse the responses into easy-to-use Ruby objects via the whois-parser library.".freeze
  s.email = ["weppos@weppos.net".freeze]
  s.executables = ["whoisrb".freeze]
  s.extra_rdoc_files = ["LICENSE.txt".freeze, ".yardopts".freeze]
  s.files = [".github/FUNDING.yml".freeze, ".github/dependabot.yml".freeze, ".github/workflows/codeql-analysis.yml".freeze, ".github/workflows/release.yml".freeze, ".github/workflows/tests.yml".freeze, ".gitignore".freeze, ".rspec".freeze, ".rubocop.yml".freeze, ".rubocop_opinionated.yml".freeze, ".rubocop_todo.yml".freeze, ".simplecov".freeze, ".tool-versions".freeze, ".yardopts".freeze, "4.0-Upgrade.md".freeze, "CHANGELOG.md".freeze, "CONTRIBUTING.md".freeze, "Gemfile".freeze, "LICENSE.txt".freeze, "README.md".freeze, "Rakefile".freeze, "SECURITY.md".freeze, "bin/console".freeze, "bin/whoisrb".freeze, "data/asn16.json".freeze, "data/asn32.json".freeze, "data/ipv4.json".freeze, "data/ipv6.json".freeze, "data/tld.json".freeze, "lib/whois.rb".freeze, "lib/whois/client.rb".freeze, "lib/whois/errors.rb".freeze, "lib/whois/record.rb".freeze, "lib/whois/record/part.rb".freeze, "lib/whois/server.rb".freeze, "lib/whois/server/adapters/afilias.rb".freeze, "lib/whois/server/adapters/arin.rb".freeze, "lib/whois/server/adapters/arpa.rb".freeze, "lib/whois/server/adapters/base.rb".freeze, "lib/whois/server/adapters/formatted.rb".freeze, "lib/whois/server/adapters/none.rb".freeze, "lib/whois/server/adapters/not_implemented.rb".freeze, "lib/whois/server/adapters/standard.rb".freeze, "lib/whois/server/adapters/verisign.rb".freeze, "lib/whois/server/adapters/web.rb".freeze, "lib/whois/server/socket_handler.rb".freeze, "lib/whois/version.rb".freeze, "spec/fixtures/referrals/afilias.bz.txt".freeze, "spec/fixtures/referrals/arin_referral_apnic.txt".freeze, "spec/fixtures/referrals/arin_referral_missing.txt".freeze, "spec/fixtures/referrals/arin_referral_ripe.txt".freeze, "spec/fixtures/referrals/arin_referral_rwhois.txt".freeze, "spec/fixtures/referrals/arin_referral_servernap.txt".freeze, "spec/fixtures/referrals/arin_referral_whois.txt".freeze, "spec/fixtures/referrals/crsnic.com.txt".freeze, "spec/fixtures/referrals/crsnic.com_referral.txt".freeze, "spec/fixtures/referrals/crsnic.com_referral_missing.txt".freeze, "spec/integration/whois_spec.rb".freeze, "spec/spec_helper.rb".freeze, "spec/support/helpers/connectivity_helper.rb".freeze, "spec/support/helpers/spec_helper.rb".freeze, "spec/whois/client_spec.rb".freeze, "spec/whois/record/part_spec.rb".freeze, "spec/whois/record_spec.rb".freeze, "spec/whois/server/adapters/afilias_spec.rb".freeze, "spec/whois/server/adapters/arin_spec.rb".freeze, "spec/whois/server/adapters/arpa_spec.rb".freeze, "spec/whois/server/adapters/base_spec.rb".freeze, "spec/whois/server/adapters/formatted_spec.rb".freeze, "spec/whois/server/adapters/none_spec.rb".freeze, "spec/whois/server/adapters/not_implemented_spec.rb".freeze, "spec/whois/server/adapters/standard_spec.rb".freeze, "spec/whois/server/adapters/verisign_spec.rb".freeze, "spec/whois/server/adapters/web_spec.rb".freeze, "spec/whois/server/socket_handler_spec.rb".freeze, "spec/whois/server_spec.rb".freeze, "spec/whois/web_interface_error_spec.rb".freeze, "spec/whois/whois_spec.rb".freeze, "utils/compare-whois.rb".freeze, "utils/deftld.rb".freeze, "utils/defutils.rb".freeze, "utils/fixupd.rb".freeze, "utils/matrix.rb".freeze, "utils/mkwhois.rb".freeze, "whois.gemspec".freeze]
  s.homepage = "https://whoisrb.org/".freeze
  s.licenses = ["MIT".freeze]
  s.required_ruby_version = Gem::Requirement.new(">= 3.0".freeze)
  s.rubygems_version = "3.5.11".freeze
  s.summary = "An intelligent pure Ruby WHOIS client and parser.".freeze

  s.specification_version = 4

  s.add_development_dependency(%q<rake>.freeze, [">= 0".freeze])
  s.add_development_dependency(%q<rspec>.freeze, [">= 0".freeze])
  s.add_development_dependency(%q<yard>.freeze, [">= 0".freeze])
end

